#include <iostream>
#include <string.h>

#include "bussim_dhid.h"
#include "netex_line_master.h"
#include "netex_line.h"

using namespace std;

int main(int argc, char** argv)
{
    class DHID_LIST *ExtractedList;
    ExtractedList = new class DHID_LIST();

    // try to read existing command line options and store them in the configuration object
    for (int k = 0; k < argc; k++)
	{
		if (strcmp(argv[k], "-s") == 0)
		{
			// we are talking about the xml-scenario file
			// go to the submitted value itself
			k++;
			// save the submitted value
			ExtractedList->set_name(argv[k]);
		}
	}

    // import the netex file list
    ExtractedList->import_netexfile_list(ExtractedList->get_name()+".xml");

    // inspect siteframe
    for(long f=0 ; f < ExtractedList->get_files() ; f++ )
    {
        ExtractedList->analyze_from_netex_xml(ExtractedList->get_file_name_at_list_pos(f));
        ExtractedList->analyze_from_netex_xml_lines(ExtractedList->get_file_name_at_list_pos(f));
    }

    // export everything found to xml

    // export the quay list
    ExtractedList->export_quay_list_to_xml();
    // export the service pattern
    ExtractedList->export_line_list_to_xml();

    return 0;
}
