#include "netex_line.h"
#include "bussim_dhid.h"
#include <string>
#include <iostream>

using namespace std;

NetexLine_List::NetexLine_List()
{
    // the standard constructor
    this->NetexLines = 0;
    this->ref2first = nullptr;
    this->ref2last = nullptr;
}

NetexLine_List::~NetexLine_List()
{
    // the standard destructor
        // the standard destructor

    if( this->ref2first != nullptr )
    {
        // some this is stored here
        if( this->ref2first == this->ref2last )
        {
            // exactly one item is stored
            delete this->ref2first;
            this->ref2first = nullptr;
            this->ref2last = nullptr;
            this->NetexLines--;
        }
        else
        {
            // at least two items are stored
            class NetexLine *TmpPtr;
            TmpPtr = this->ref2last;
            while( TmpPtr->ptr2prev != nullptr )
            {
                TmpPtr = TmpPtr->ptr2prev;
                delete TmpPtr->ptr2next;
                TmpPtr->ptr2next = nullptr;
                this->ref2last = TmpPtr;
                this->NetexLines--;
            }
            if( TmpPtr != nullptr )
            {
                // exactly one item is stored
                delete TmpPtr;
                this->ref2first = nullptr;
                this->ref2last = nullptr;
                this->NetexLines--;
            }
        }
    }
}

void NetexLine_List::Append_NetexLine(class NetexLine *_NetexLine)
{
    if( this->ref2first != nullptr )
    {
        _NetexLine->ptr2prev = this->ref2last;
        _NetexLine->ptr2next = nullptr;
        this->ref2last->ptr2next = _NetexLine;
        this->ref2last = _NetexLine;
        this->NetexLines++;
    }
    else
    {
        // nothing stored so far
        this->ref2first = _NetexLine;
        this->ref2last = _NetexLine;
        this->NetexLines++;
    }
}

void NetexLine_List::print(void)
{
    class NetexLine *Tmp;
    Tmp = this->ref2first;
    while( Tmp != nullptr )
    {
        Tmp->print();
        Tmp = Tmp->ptr2next;
    }

}

long NetexLine_List::get_NetexLines(void)
{
    return( this->NetexLines );
}

class NetexLine *NetexLine_List::already_stored_ServiceJourneyPattern_ID(std::string _ServiceJourneyPattern_ID)
{
       // prepare the return value
    class NetexLine *RetPtr, *TmpPtr;
    RetPtr = nullptr;

    // run through the list of stored Items
    TmpPtr = this->ref2first;
    while( TmpPtr != nullptr )
    {
        if( (TmpPtr->ServiceJourneyPattern_ID == _ServiceJourneyPattern_ID)
           )
        {
            // matching item found
            RetPtr = TmpPtr;
            TmpPtr = nullptr;
        }
        else
        {
            // go to next item
            TmpPtr = TmpPtr->ptr2next;
        }
    }

    return(RetPtr);
}


NetexLine::NetexLine()
{
    this->NetexLine_ID = "undefined netexline_id";
    this->ServiceJourneyPattern_ID = "undefined ServiceJourneyPattern_ID";
    this->ID = -1;
    this->LineNumberPublic = "undefined linenumberpublic";
    this->Mode = "undefined mode";
    this->RED = -1.0;
    this->GREEN = -1.0;
    this->BLUE = -1.0;

    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

    this->FirstStop = nullptr;
    this->LastStop = nullptr;

    this->LineStops = 0;
}

NetexLine::NetexLine(std::string _NetexLine_ID, std::string _ServiceJourneyPattern_ID, long _ID, std::string _LineNumberPublic, std::string _Mode,
                     double _RED, double _GREEN, double _BLUE)
{
    this->NetexLine_ID = _NetexLine_ID;
    this->ServiceJourneyPattern_ID = _ServiceJourneyPattern_ID;
    this->ID = _ID;
    this->LineNumberPublic = _LineNumberPublic;
    this->Mode = _Mode;
    this->RED = _RED;
    this->GREEN = _GREEN;
    this->BLUE = _BLUE;

    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

    this->FirstStop = nullptr;
    this->LastStop = nullptr;

    this->LineStops = 0;
}

NetexLine::~NetexLine()
{
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

    this->FirstStop = nullptr;
    this->LastStop = nullptr;
    // muss noch erweitert werden um lschung der netex_line_stop_elements
}

void NetexLine::print(void)
{
    std::cout << "NetexLine: NetexLine-ID: "
            << this->NetexLine_ID
            << "\t public linenumber: " << this->LineNumberPublic
            << "\t servicejourneypatternid: " << this->ServiceJourneyPattern_ID
            << "\t ID: " << this->ID
            << "\t Mode: " << this->Mode
            << "\t" << this->RED << "\t" << this->GREEN << "\t" << this->BLUE
            <<std::endl;
    std::cout << "the stop sequence ("<<this->get_netex_line_stops()<<" stops)" << std::endl;
    class NetexLineStop *Ptr2Stop;
    Ptr2Stop = this->FirstStop;
    while(Ptr2Stop != nullptr)
    {
        if( Ptr2Stop->Ref2NetexLine != nullptr )
            std::cout << "-->" << Ptr2Stop->Ref2NetexLine->LineNumberPublic << " - " << Ptr2Stop->DHID.ORIGINAL_CODE << " / " << Ptr2Stop->DHID.OriginalName << std::endl;
        else
            std::cout << "-->" << Ptr2Stop->DHID.ORIGINAL_CODE << " / " << Ptr2Stop->DHID.OriginalName << std::endl;

        Ptr2Stop = Ptr2Stop->next;
    }
}

void NetexLine::append_netex_line_stop(class NetexLineStop *_Ptr)
{
    if( this->FirstStop != nullptr )
    {
        _Ptr->prev = this->LastStop;
        _Ptr->next = nullptr;
        this->LastStop->next = _Ptr;
        this->LastStop = _Ptr;
        this->LineStops++;
    }
    else
    {
        // nothing stored so far
        this->FirstStop = _Ptr;
        this->LastStop = _Ptr;
        this->LineStops++;
    }
}

long NetexLine::get_netex_line_stops(void)
{
    return( this->LineStops );
}
