#ifndef NETEX_LINE_H_INCLUDED
#define NETEX_LINE_H_INCLUDED

#include <string>
#include "bussim_dhid.h"
#include "netex_line_stop.h"

class NetexLine_List {

    friend class NetexLine;
    friend class DHID_LIST;

    // this object hosts a double-linked list of NetexLine-Objects
    long NetexLines;        // the number of stored NetexLine-Items
    class NetexLine *ref2first;  // pointer to first stored NetexLineMaster-Item
    class NetexLine *ref2last;  // pointer to first stored NetexLineMaster-Item

public:
    NetexLine_List();    // the standard constructor
    ~NetexLine_List();   // the standard destructor

    void Append_NetexLine(class NetexLine *_NetexLine);
    void print(void);
    long get_NetexLines(void);
    class NetexLine *already_stored_ServiceJourneyPattern_ID(std::string _ServiceJourneyPattern_ID);
};

class NetexLine {

    friend class NetexLine_List;
    friend class DHID_LIST;

    std::string NetexLine_ID;
    std::string ServiceJourneyPattern_ID;
    long ID;
    long LineStops;
    std::string LineNumberPublic;
    std::string Mode;
    double RED;
    double GREEN;
    double BLUE;

    class NetexLine *ptr2prev;
    class NetexLine *ptr2next;

    class NetexLineStop *FirstStop;
    class NetexLineStop *LastStop;

public:
    NetexLine();
    NetexLine(std::string _NetexLine_ID, std::string ServiceJourneyPattern_ID, long _ID, std::string _LineNumberPublic, std::string _Mode,
                     double _RED, double _GREEN, double _BLUE);
    ~NetexLine();
    void print(void);
    void append_netex_line_stop(class NetexLineStop *_Ptr);
    long get_netex_line_stops(void);
};



#endif // NETEX_LINE_H_INCLUDED
