#include <iostream>
#include <string.h>
#include "netex_line_master.h"
#include "netex_line.h"
#include "PUGIXML/pugixml.hpp"

using namespace std;

NetexLineMaster_List::NetexLineMaster_List()
{
     // the standard constructor
     this->NetexLineMasters = 0;
     this->ref2first = nullptr;
     this->ref2last = nullptr;
}

NetexLineMaster_List::~NetexLineMaster_List()
{
    // the standard destructor

    if( this->ref2first != nullptr )
    {
        // some this is stored here
        if( this->ref2first == this->ref2last )
        {
            // exactly one item is stored
            delete this->ref2first;
            this->ref2first = nullptr;
            this->ref2last = nullptr;
            this->NetexLineMasters--;
        }
        else
        {
            // at least two items are stored
            class NetexLineMaster *TmpPtr;
            TmpPtr = this->ref2last;
            while( TmpPtr->ptr2prev != nullptr )
            {
                TmpPtr = TmpPtr->ptr2prev;
                delete TmpPtr->ptr2next;
                TmpPtr->ptr2next = nullptr;
                this->ref2last = TmpPtr;
                this->NetexLineMasters--;
            }
            if( TmpPtr != nullptr )
            {
                // exactly one item is stored
                delete TmpPtr;
                this->ref2first = nullptr;
                this->ref2last = nullptr;
                this->NetexLineMasters--;
            }
        }
    }

}

void NetexLineMaster_List::Append_NetexLineMaster(class NetexLineMaster *_NetexLineMaster)
{
    if( this->ref2first != nullptr )
    {
        _NetexLineMaster->ptr2prev = this->ref2last;
        _NetexLineMaster->ptr2next = nullptr;
        this->ref2last->ptr2next = _NetexLineMaster;
        this->ref2last = _NetexLineMaster;
        this->NetexLineMasters++;
    }
    else
    {
        // nothing stored so far
        this->ref2first = _NetexLineMaster;
        this->ref2last = _NetexLineMaster;
        this->NetexLineMasters++;
    }
}

void NetexLineMaster_List::print(void)
{
    class NetexLineMaster *Tmp;
    Tmp = this->ref2first;
    while( Tmp != nullptr )
    {
        Tmp->print();
        Tmp = Tmp->ptr2next;
    }

}

long NetexLineMaster_List::get_NetexLineMasters(void)
{
    return( this->NetexLineMasters );
}

class NetexLineMaster *NetexLineMaster_List::already_stored_netexid(std::string _NETEX_Id)
{
    // prepare the return value
    class NetexLineMaster *RetPtr, *TmpPtr;
    RetPtr = nullptr;

    // run through the list of stored StopPlaceItems
    TmpPtr = this->ref2first;
    while( TmpPtr != nullptr )
    {
        if( (TmpPtr->Netex_ID == _NETEX_Id)
           )
        {
            // matching item found
            RetPtr = TmpPtr;
            TmpPtr = nullptr;
        }
        else
        {
            // go to next item
            TmpPtr = TmpPtr->ptr2next;
        }
    }

    return(RetPtr);

}

NetexLineMaster::NetexLineMaster()
{
    this->Netex_ID = "undefined";
    this->Operator = "undefined";
    this->Authority = "undefined";
    this->ShortName = "undefined";
    this->AssocLineList = new class NetexLine_List();
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;
}

NetexLineMaster::NetexLineMaster(std::string _Netex_ID, std::string _Operator)
{
    this->Netex_ID = _Netex_ID;
    this->Operator = _Operator;
    this->Authority = "undefined";
    this->ShortName = "undefined";
    this->AssocLineList = new class NetexLine_List();
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

}

NetexLineMaster::NetexLineMaster(std::string _Netex_ID, std::string _Operator, std::string _Authority, std::string _ShortName)
{
    this->Netex_ID = _Netex_ID;
    this->Operator = _Operator;
    this->Authority = _Authority;
    this->ShortName = _ShortName;
    this->AssocLineList = new class NetexLine_List();
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

}

NetexLineMaster::NetexLineMaster(std::string _Netex_ID, std::string _Operator, std::string _Authority)
{
    this->Netex_ID = _Netex_ID;
    this->Operator = _Operator;
    this->Authority = _Authority;
    this->ShortName = "undefined";
    this->AssocLineList = new class NetexLine_List();
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;

}

NetexLineMaster::~NetexLineMaster()
{
    this->ptr2prev = nullptr;
    this->ptr2next = nullptr;
    delete this->AssocLineList;
}

void NetexLineMaster::print(void)
{
    std::cout << "NetexLineMaster: Netex-ID: "
            << this->Netex_ID
            << " operator: "
            << this->Operator
            << " authority: "
            << this->Authority
            << " shortname: "
            << this->ShortName <<std::endl;
    std::cout << "associated netex line instances (" << this->AssocLineList->get_NetexLines()<<")" << std::endl;
    this->AssocLineList->print();
}
