#ifndef NETEX_LINE_MASTER_H_INCLUDED
#define NETEX_LINE_MASTER_H_INCLUDED

#include <string.h>

class NetexLineMaster_List {

    friend class NetexLineMaster;
    friend class DHID_LIST;

    // this object hosts a double-linked list of NetexLineMaster-Objects
    long NetexLineMasters;        // the number of stored NetexLineMaster-Items
    class NetexLineMaster *ref2first;  // pointer to first stored NetexLineMaster-Item
    class NetexLineMaster *ref2last;  // pointer to first stored NetexLineMaster-Item


public:
    NetexLineMaster_List();    // the standard constructor
    ~NetexLineMaster_List();   // the standard destructor

    void Append_NetexLineMaster(class NetexLineMaster *_NetexLineMaster);
    void print(void);
    long get_NetexLineMasters(void);
    class NetexLineMaster *already_stored_netexid(std::string _NETEX_Id);
};

class NetexLineMaster{

    friend class NetexLineMaster_List;
    friend class DHID_LIST;

    std::string Netex_ID;
    std::string Authority;
    std::string Operator;

    std::string ShortName;

    class NetexLine_List *AssocLineList;    // list of pattern assoc to this masterline

    class NetexLineMaster *ptr2prev;
    class NetexLineMaster *ptr2next;

public:
    NetexLineMaster();
    NetexLineMaster(std::string _Netex_ID, std::string _Operator);
    NetexLineMaster(std::string _Netex_ID, std::string _Operator, std::string _Authority);
    NetexLineMaster(std::string _Netex_ID, std::string _Operator, std::string _Authority, std::string _ShortName);

    ~NetexLineMaster();
    void print(void);

};

#endif // NETEX_LINE_MASTER_H_INCLUDED
