#ifndef NETEX_LINE_STOP_H_INCLUDED
#define NETEX_LINE_STOP_H_INCLUDED

#include <string>
#include "bussim_dhid.h"
using namespace std;

class NetexLineStop {

    friend class NetexLine;
    friend class DHID_LIST;

    std::string StopPointInJourneyPattern;      // refers to the id in the netex export
    int ForAlighting;
    int ForBoarding;
    int ChangeOfDestinationDisplay;
    std::string DestinationDisplayTextFront;
    std::string DestinationDisplayTextSide;

    class DHID_ID DHID;

    class NetexLineStop *prev;
    class NetexLineStop *next;

    class NetexLine *Ref2NetexLine;

public:
    NetexLineStop();
    NetexLineStop(std::string _StopPointInJourneyPattern,
                             int _ForAlighting,
                             int _ForBoarding,
                             int _ChangeOfDestinationDisplay,
                             std::string _DestinationDisplayTextFront,
                             std::string _DestinationDisplayTextSide,
                             class DHID_ID _DHID,
                             class NetexLine *_Ref2NetexLine);
    ~NetexLineStop();
};

#endif // NETEX_LINE_STOP_H_INCLUDED
